%% Audio test


%% Open function generator and scope

fg = gpib('agilent',7,10);
os = gpib('agilent',7,7);
fopen(fg)
fopen(os)
fprintf(fg,'*IDN?');
idn = fscanf(fg);
fprintf('function generator: %s',idn);
fprintf(os,'*IDN?');
idn = fscanf(os);
fprintf('oscilloscope: %s',idn);
clear idn;

% Set fg output load
fprintf(fg,'Output:Load INF');

%% setup for data acquisition

npts = 41;
freq = logspace(0,4,npts)';
y = zeros(npts,5);
fprintf(fg,'FREQ %g',freq(1));

%% take data

for k=1:npts
    fprintf(fg,'FREQ %g',freq(k));
    y(k,:) = get_data(os,freq(k));    
end

%% show data

subplot(2,1,1);
yratio = 10*y(:,4);
yphase = y(:,5);
semilogx(freq,yratio,'ko-','LineWidth',2);
ylabel('voltage ratio');
subplot(2,1,2);
semilogx(freq,yphase,'ko-','LineWidth',2);
xlabel('frequency (Hz)');
ylabel('phase (degrees)');

%% save data

save scan2 freq y yratio yphase

%% Close all instruments

g = instrfind;
for k=1:length(g)
    fclose(g(k));
    delete(g(k));
end
clear
close all
