function y = get_data(os,fq)
%
% Use oscilloscope to measure
%   y = [freq v1 v2 v2/v1 phase]
% 

if fq>20
    fprintf(os,'Autoscale');
    pause(0.5);
else
    fprintf('frequency: %g Hz',fq);
    fprintf('adjust scope, then hit enter');
    pause;
end
fprintf(os,'Measure:Freq CHAN1');
fprintf(os,'Measure:Vamp CHAN2');
fprintf(os,'Measure:Phase');
fprintf(os,'Measure:Freq? CHAN1');
freq = fscanf(os,'%g');
fprintf(os,'Measure:Vamp? CHAN1');
vout = fscanf(os,'%g');
fprintf(os,'Measure:Vamp? CHAN2');
vin = fscanf(os,'%g');
fprintf(os,'Measure:Phase?');
phase = fscanf(os,'%g');
if (abs(phase)>1e5) 
    phase = 0.0;
end
y = [ freq vin vout vout/vin phase ];
fprintf('freq %g Hz vratio %g phase %g deg\n',freq,vout/vin,phase);
end
