%% Identify Lab instruments

%% Query for hardware information

gh = instrhwinfo('visa','agilent');
disp(gh);

%% Query individual instruments

n = length(gh.ObjectConstructorName);
for k=1:n
    str = char(gh.ObjectConstructorName(k));
    obj = eval(str);
    fopen(obj);
    fprintf(obj,'*IDN?');
    idn = fscanf(obj);
    fprintf('\ninterface: %s\n',str);
    fprintf('identification: %s\n',idn);
    if regexp(idn,'33120A')>0
        fg = obj;
    elseif regexp(idn,'MSO7012B')>0
        os = obj;
    else
        fclose(obj);
        delete(obj);
        clear obj;
    end
end

%% Open function generator and scope

% Note that the order of the object depends on which was connected first
% or how the interface adds the instruments.
%fg = eval(char(gh.ObjectConstructorName(3)));
%os = eval(char(gh.ObjectConstructorName(1)));

%% Configure the function generator

fprintf(fg,'APPLY:TRIANGLE 1500, 1');
fprintf(fg,'APPLY?');
query = fscanf(fg);
disp(query);

%% Configure the oscilloscope

fprintf(os,':AUTOSCALE')
fprintf(os,':MEASURE:FREQ');
fprintf(os,':MEASURE:VRMS');
fprintf(os,':MEASURE:VPP');
fprintf(os,':MEAS:FREQ?');
freq = fscanf(os,'%g');
fprintf('frequency: %g Hz\n',freq);
fprintf(os,':MEAS:VPP?');
vpp = fscanf(os,'%g');
fprintf('vpp: %g V\n',vpp);
fprintf(os,':MEAS:VRMS?');
vrms = fscanf(os,'%g');
fprintf('vrms: %g V\n',vrms);

%% Close all instruments

g = instrfind;
for k=1:length(g)
    fclose(g(k));
    delete(g(k));
end
clear g os fg;